;
;   s m s _ u t h g
;
; routine to use a thing
; equal to C routine
;   char * sms_uthg( char *name, timeout_t timeout, jobidd_t job_id,
;                     long * d2, void * a2, long * version, void ** a2 )
;
; AMENDMENT HISTORY
; ~~~~~~~~~~~~~~~~~
;   24 Jul 93   DJW   - First version
;
;   06 Nov 93   DJW   - Added underscore to entry point name
;
;   23 Jan 94   DJW   - Changed to call an exeternal rputine rather than
;                       trap #1 to allow for systems where the trap is not
;                       available and a vector has to be called instead.
;
;   03 Sep 94   DJW   - Added underscore to _cstr_to_ql for name hiding reasons

    .text
    .even
    .globl _sms_uthg        ; SMS name for call

WORKLEN equ 50              ; size of stack work area reserved for QL format name
SMS.UTHG equ $28

_sms_uthg:
    link    a5,#-WORKLEN                ; create workspace on stack
    movem.l d2/d3/a2/a3,-(sp)
    move.l  4+4(a5),-(a7)               ; name
    pea.l   -WORKLEN(a5)                ; qlstr location
    jsr     __cstr_to_ql                ; convert to qlstr
    addq.l  #8,a7                       ; tidy up stack
    move.l  d0,a0                       ; qlstr
    move.l  8+4(a5),d1                  ; job id
    move.w  12+4(a5),d3                 ; timeout
    moveq   #0,d2
    move.l  14+4(a5),a2                 ; user d2 parameter pointer
    cmp.l   #0,a2
    beq     uthg01
    move.l  (a2),d2
uthg01:
    move.l  18+4(a5),a2                 ; user a2 parameter
    moveq.l #SMS.UTHG,d0                ; byte code for trap
    jsr     ThingTrap                   ; ... do it
    move.l  14+4(a5),a0
    cmp.l   #0,a0
    beq     uthg02
    move.l  d2,(a0)                     ; returned d2 value
uthg02:
    move.l  22+4(a5),a0
    move.l  d3,(a0)                     ; version
    move.l  26+4(a5),a0
    move.l  a2,(a0)                     ; linkage block
    tst.l   d0                          ; OK ?
    bne     fin                         ; ... NO, exit with error code
    move.l  a1,d0                       ; ... YES, set Thing address as reply
fin:
    movem.l (sp)+,d2/d3/a2/a3
    unlk    a5                          ; remove stack workspace
    rts
